<?php
error_reporting(E_ALL ^ E_NOTICE);

// Permite la ejecución de los métodos
header("Access-Control-Allow-Methods: GET, POST, PUT, DELETE");
header("Content-Type: application/json; charset=utf-8");

// Se incluye el archivo que contiene la conexión a PostgreSQL
include_once '../conexion.php';
include_once '../clases/TokenValidator.php';

// Llama la validación antes de cualquier consulta
$usuarioId = TokenValidator::validar($conn);

$bodyRequest = file_get_contents("php://input");
// Decodifica el cuerpo de la solicitud y lo guarda en un array de PHP
$datos = json_decode($bodyRequest, true);

$rows = array();

try {
    // Preparar la llamada al procedimiento almacenado o función en PostgreSQL
    $sql = "SELECT * FROM Buscar_Marca_Informe(:param1, :param2);"; // Cambia "Buscar_Marca_Informe" por tu función o procedimiento
    $stmt = $conn->prepare($sql);

    // Vincular los parámetros
    $stmt->bindValue(':param1', $datos[0], PDO::PARAM_INT); // Ajusta el tipo de dato según corresponda
    $stmt->bindValue(':param2', $datos[1], PDO::PARAM_STR);  // Ajusta el tipo de dato según corresponda

    // Ejecutar la consulta
    $stmt->execute();

    // Obtener el resultado de la función o procedimiento
    $rows = $stmt->fetchAll(PDO::FETCH_ASSOC);

    if (empty($rows)) {
        // No se encontraron registros
        $rows = [];
    }
} catch (PDOException $e) {
    error_response("Error al ejecutar la consulta: " . $e->getMessage());
}

// Cerrar la conexión a la base de datos
$conn = null;

// Imprimir la respuesta en formato JSON
print_json($rows);

function print_json($data) {
    echo json_encode($data, JSON_UNESCAPED_UNICODE);

    switch (json_last_error()) {
        case JSON_ERROR_NONE:
            break;
        case JSON_ERROR_DEPTH:
            error_response('Maximum stack depth exceeded');
            break;
        case JSON_ERROR_STATE_MISMATCH:
            error_response('Underflow or the modes mismatch');
            break;
        case JSON_ERROR_CTRL_CHAR:
            error_response('Unexpected control character found');
            break;
        case JSON_ERROR_SYNTAX:
            error_response('Syntax error, malformed JSON');
            break;
        case JSON_ERROR_UTF8:
            error_response('Malformed UTF-8 characters, possibly incorrectly encoded');
            break;
        default:
            error_response('Unknown error');
            break;
    }
}

function error_response($message) {
    http_response_code(500);
    echo json_encode(['error' => $message], JSON_UNESCAPED_UNICODE);
    exit();
}
?>
